
(exit "$?") &&
prj_unset sp_path sp_dir sp_root sp_category sp_base sp_version sp_dashdigit \
  sp_skip sp_tardir sp_ext sp_tar sp_tar_base sp_id sp_hook_status &&
sp_process_non_directory() { :; } &&
sp_process_package_current() { :; } &&
sp_process_package_version() { :; } &&
sp_dashdigit='-[0123456789]' &&

sp_parse() {
  sp_path=$1 &&
  sp_dir=` prj_dirname  "$sp_path"` &&
  sp_base=`prj_basename "$sp_path"` &&
  sp_version='
/'$sp_dashdigit'/!d
:trim
s%^.[^-]*--*%-%
/^'$sp_dashdigit'/!btrim
' &&
  sp_version=`prj_sedarg1 "$sp_version" "$sp_base"` &&
  sp_base=`prj_sedarg1 "s%\(.\)$sp_dashdigit.*$%\1%" "$sp_base"` &&
  case $sp_dir in
    "$SP_ROOT"/package/*) sp_root=$SP_ROOT;;
    /package/*) sp_root=;;
    *) prj_unset sp_category sp_root && return 0;;
  esac &&
  sp_category='s,\([][%\\.*^$]\),\\\1,g' &&
  sp_category=`prj_sedarg1 "$sp_category" "$sp_root"` &&
  sp_category=`prj_sedarg1 "s%^$sp_category/package/%%" "$sp_dir"`
} &&

sp_find_tar() {
  for sp_tardir in ${SP_TARDIR_FLAT+"$SP_TARDIR_FLAT/"} \
                   ${SP_TARDIR+"$SP_TARDIR/$sp_category"} \
                   "$SP_ROOT"/usr/local/src/package/"$sp_category" \
                   /usr/local/src/package/"$sp_category" end; do
    { if test end = "$sp_tardir"; then break; else :; fi &&
      for sp_ext in .gz .bz2 .Z '' end; do
        { sp_tar=$sp_tardir${sp_tar_base-$sp_base$sp_version.tar$sp_ext} &&
          if test end != "$sp_ext" &&
             test -f  "$sp_tar"
            then return 0
            else :
          fi
        } || return "$?"
      done
    } || return "$?"
  done &&
  sp_tar=not_found
} &&

sp_for_each_package() {
  if test 0 = "$#"; then set "$SP_ROOT"/package; else :; fi &&
  while test 0 != "$#"; do
    { sp_path=`prj_sedarg1 's%/*$%%' "$1"` &&
      shift &&
      if test -k "$sp_path"/.; then
        # this is a category; push its subdirectories on the stack
        set x "$sp_path"/[*] "$sp_path"/* ${1+"$@"} && shift &&
        if test x"$1" = x"$sp_path/[*]" && test x"$2" = x"$sp_path/*"
          then shift
          else :
        fi &&
        shift &&
        continue
      else :
      fi &&
      # this is a package
      sp_parse "$sp_path" &&
      if test -d "$sp_path"/.; then :; else
        sp_skip=y &&
        sp_process_non_directory &&
        if test y = "$sp_skip"; then continue; else :; fi
      fi &&
      if test '' = "$sp_version"
        then sp_process_package_current
        else sp_process_package_version
      fi
    } || return "$?"
  done
} &&

sp_validate_root() {
  case $SP_ROOT in
    [!/]*) prj_fail '$SP_ROOT must specify an absolute path';;
    *) :;;
  esac
} &&

if ( exec wget -V ) > /dev/null 2>&1; then
  sp_download() { ( cd "$2" && rm -f "$3" && exec wget -nv "$1" ); }
elif ( exec lynx -version ) > /dev/null 2>&1; then
  sp_download() { ( cd "$2" && rm -f "$3" && exec lynx -source "$1" > "$3" ); }
elif ( exec lftp --version ) > /dev/null 2>&1; then
  sp_download() { ( cd "$2" && rm -f "$3" && exec lftp -c "get $1" ); }
else
  sp_download() { prj_fail 'unable to find a download program'; }
fi &&

sp_hook() {
  sp_hook_status=0 &&
  if prj_is_set SP_HOOK; then
    ( prj_x2 prj_set SP_PATH "$sp_path" &&
      prj_x2 prj_set SP_DIR "$sp_dir" &&
      if prj_is_set sp_root
        then prj_x2 prj_set SP_PATH_ROOT "$sp_root"
        else prj_unset SP_PATH_ROOT
      fi &&
      if prj_is_set sp_category
        then prj_x2 prj_set SP_CATEGORY "$sp_category"
        else prj_unset SP_CATEGORY
      fi &&
      prj_x2 prj_set SP_BASE "$sp_base" &&
      prj_x2 prj_set SP_VERSION "$sp_version" &&
      exec "$SP_HOOK" "$1"
    )
    sp_hook_status=$? &&
    if test "$sp_hook_status" = 99
      then return 0
      else return "$sp_hook_status"
    fi
  else :
  fi
} &&

sp_unpack() {
  if prj_is_set SP_COMPILE_USER; then
    if test -d "$sp_path"/.; then :; else
      prj_mkdir_p "$sp_path" &&
      set x "$sp_dir" && shift &&
      while :; do
        { if test "$sp_root"/package/ = "$sp_dir" || test -k "$sp_dir"/.
            then break
            else :
          fi &&
          chmod +t "$sp_dir"/. &&
          sp_dir=`prj_sedarg1 's%//*[^/][^/]*//*$%/%' "$sp_dir"` &&
          if test "$sp_dir" = "$sp_root"/package/; then break; else :; fi
        } || return "$?"
      done &&
      sp_dir=$1
    fi &&
    sp_id=`prj_id -u "$SP_COMPILE_USER"` &&
    chown -R "$sp_id" "$sp_path"/. &&
    ( cd "$sp_root"/package &&
      exec setuidgid "$SP_COMPILE_USER" tar -xpf - \
        "$sp_category$sp_base$sp_version"
    ) < "$sp_tar" &&
    sp_id=`prj_id -u` &&
    sp_id=$sp_id:`prj_id -g` &&
    chown -R "$sp_id" "$sp_path"/.
  else
    ( cd "$sp_root"/package && exec tar -xpf - ) < "$sp_tar"
  fi
}
